# class HTTP::Server::Response

- HTTP::Server::Response
- IO
- Reference
- Object

##
Overview

The response to configure and write to in an `HTTP::Server` handler.

The response `#status` and `#headers` must be configured before writing the response body. Once response output is written, changing the `#status` and `#headers` properties has no effect.

The `HTTP::Server::Response` is a write-only `IO`, so all `IO` methods are available in it.

A response can be upgraded with the `#upgrade` method. Once invoked, headers are written and the connection `IO` (a socket) is yielded to the given block. The block must invoke `#close` afterwards, the server won't do it in this case. This is useful to implement protocol upgrades, such as websockets.

##
Defined in:

##
Instance Method Summary

- #close

  Closes this response, writing headers and body if not done yet.

- #closed?

  Returns `true` if this response has been closed.

- #content_length=(content_length : Int)

  Convenience method to set the `Content-Length` header.

- #content_type=(content_type : String)

  Convenience method to set the `Content-Type` header.

- #cookies

  Convenience method to set cookies, see `HTTP::Cookies`.

- #flush

  Flushes the output.

- #headers : HTTP::Headers

  The response headers (`HTTP::Headers`).

- #output : IO

  The `IO` to which output is written.

- #output=(output : IO)

  The `IO` to which output is written.

- #respond_with_error(message = "Internal Server Error", code = 500)

  Sends an error response.

  DEPRECATED Use #respond_with_status instead

- #respond_with_status(status : Int, message : String? = nil)

  Sends status and message as response.

- #respond_with_status(status : HTTP::Status, message : String? = nil)

  Sends status and message as response.

- #status : HTTP::Status

  The status code of this response, which must be set before writing the response body.

- #status=(status : HTTP::Status)

  The status code of this response, which must be set before writing the response body.

- #status_code

  Convenience method to retrieve the HTTP status code.

- #status_code=(status_code : Int32)

  Convenience method to set the HTTP status code.

- #upgrade(&)

  Upgrades this response, writing headers and yieling the connection `IO` (a socket) to the given block.

- #version : String

  The version of the HTTP::Request that created this response.

- #write(slice : Bytes) : Nil

  See `IO#write(slice)`.

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, gets(delimiter : Char, limit : Int, chomp = false) : String?
gets(delimiter : Char, chomp = false) : String?
gets(chomp = true) : String?
gets(limit : Int, chomp = false) : String?
gets(delimiter : String, chomp = false) : String? gets, gets_to_end : String gets_to_end, peek : Bytes? peek, pos pos, pos=(value) pos=, print(*objects : _) : Nil
print(obj) : Nil print, printf(format_string, *args) : Nil
printf(format_string, args : Array | Tuple) : Nil printf, puts(*objects : _) : Nil
puts : Nil
puts(obj) : Nil
puts(string : String) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, &) read_at, read_byte : UInt8? read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char? read_char, read_fully(slice : Bytes) read_fully, read_fully?(slice : Bytes) read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol? = nil) set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) write_bytes, write_utf8(slice : Bytes) write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : UInt64
copy(src, dst) : UInt64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Instance Method Detail

def close #

Closes this response, writing headers and body if not done yet. This method must be implemented if wrapping the response output.

def closed? #

Returns `true` if this response has been closed.

def content_length=(content_length : Int) #

Convenience method to set the `Content-Length` header.

def content_type=(content_type : String) #

Convenience method to set the `Content-Type` header.

def cookies #

Convenience method to set cookies, see `HTTP::Cookies`.

def flush #

Flushes the output. This method must be implemented if wrapping the response output.

def headers : HTTP::Headers #

The response headers (`HTTP::Headers`). These must be set before writing to the response.

def output : IO #

The `IO` to which output is written. This can be changed/wrapped to filter the response body (for example to compress the output).

def output=(output : IO) #

The `IO` to which output is written. This can be changed/wrapped to filter the response body (for example to compress the output).

def respond_with_error(message = "Internal Server Error", code = 500) #

Sends an error response.

Calls `#reset`, writes the given status, and closes the response.

DEPRECATED Use #respond_with_status instead

def respond_with_status(status : Int, message : String? = nil) #

Sends status and message as response.

This method calls `#reset` to remove any previous settings and writes the given status and message to the response IO. Finally, it closes the response.

If message is `nil`, the default message for status is used provided by `HTTP::Status#description`.

def respond_with_status(status : HTTP::Status, message : String? = nil) #

Sends status and message as response.

This method calls `#reset` to remove any previous settings and writes the given status and message to the response IO. Finally, it closes the response.

If message is `nil`, the default message for status is used provided by `HTTP::Status#description`.

def status : HTTP::Status #

The status code of this response, which must be set before writing the response body. If not set, the default value is 200 (OK).

def status=(status : HTTP::Status) #

The status code of this response, which must be set before writing the response body. If not set, the default value is 200 (OK).

def status_code #

Convenience method to retrieve the HTTP status code.

def status_code=(status_code : Int32) #

Convenience method to set the HTTP status code.

def upgrade(&) #

Upgrades this response, writing headers and yieling the connection `IO` (a socket) to the given block. The block must invoke `#close` afterwards, the server won't do it in this case. This is useful to implement protocol upgrades, such as websockets.

def version : String #

The version of the HTTP::Request that created this response.

def write(slice : Bytes) : Nil #

See `IO#write(slice)`.